-- Make require look in this folder for .lua files
package.path = debug.getinfo(1, "S").source:match[[^@?(.*[\/])[^\/]-$]] .."?.lua;".. package.path

-- Load up required files
require "utility"

function OnInit()
  SendChat "/name [Bot]Luabot"
end

function OnTick()
  OnFirstTick()
  OnTick = OnTickReal
  return OnTick()
end

function OnFirstTick()
  StartLongTask(function()
    local cities = GetCityIDs()
    local us = GetOwnTeamID()
    for i, city in ipairs(cities) do
      local long, lat, pop = city:GetLongitude(), city:GetLatitude(), city:GetCityPopulation()
      if city:GetTeamID() == us then
        DrawGoodWhiteboardCircle(long, lat, pop / 3000000)
      else
        DrawBadWhiteboardCircle(long, lat, pop / 3000000)
      end
      YieldLongTask()
    end
  end)
  
  local DefconLevel
  StartLongTask(function()
    repeat
      local Level = GetDefconLevel()
      if Level ~= DefconLevel then
        SendChat(("Oh my, it's DEFCON %i already!"):format(Level), "public")
        DefconLevel = Level
      end
      YieldLongTask()
      YieldLongTask()
      YieldLongTask()
      YieldLongTask()
    until Level == 1
    SendChat("Prepare to feel the wrath of my nuclear weaponry!", "public")
  end)
end

function OnTickReal()
  WorkOnLongTasks()
  if GetGameTick() % 60 == 0 then
	  print "Hello World!"
	end
end

function OnEvent(eventType, sourceID, targetID, unitType, longitude, latitude)
  print(eventType, ",", tostring(sourceID), ",", tostring(targetID), ",", unitType, (", %.3f , %.3f"):format(longitude, latitude))
end

function OnShutdown()
end
